// 在main.js上通过import引入Vue库和自己写的Vue组件库
import Vue from 'vue';
import 'vant/lib/index.css';
import { Picker } from "vant";
import { Icon } from "vant";
import { Popup } from "vant";
Vue.use(Popup);
Vue.use(Icon);
Vue.use(Picker);

import VueSignaturePad from 'vue-signature-pad'
Vue.use(VueSignaturePad)
import Signature from './components/Signature.vue'
import eventBus from '../../../../../../util/eventBus'
(function (KDApi) {
  function MyComponent(model) {
    this._setModel(model)
  }

  MyComponent.prototype = {
    _setModel: function (model) {
      this.model = model
    },
    init: function (props) {
      console.log('-----initSignatureYx', props)
      setHtml(this.model, props)
    },
    update: function (props) {
      console.log('-----updateSignatureYx', this.model, props)
      eventBus.pub(this.model, 'updateSignatureYx', props)
    },
    destoryed: function () {
      console.log('-----destoryed', this.model)
    }
  }

  const setHtml = (model, props) => {
    const { invoke } = model
    KDApi.loadFile('./css/index.css', model, () => {
      new Vue({
        el: model.dom,
        template:'<Signature v-on:save="save"/>',
        components: {
          Signature
        },
        data: function () {
          return {

          }
        },
        mounted() {
          const self = this
          this.updateSub = eventBus.sub(model, 'updateSignatureYx', (props) => {


          })
        },
        destroyed() {
          eventBus.unsub(this.updateSub)
        },
        methods: {
          invoke: function (eventName, args) {
            invoke(eventName, args)
          },
          save: function (data) {
            console.log("data", data)
            this.invoke("saveSignature", data)
          }
        }
      })
    })
  }

  // 注册自定义组件
  KDApi.register('SignatureYx', MyComponent)
})(window.KDApi)